import java.util.Arrays;

/**
 * ChristmasTree.
 * 
 * Ein S/W-Bild (es kennt daher nur die Helligkeitswerte 0 und 1) von der Größe
 * des Ausgabefensters wird erstellt und ein Weihnachtsbaum in dieses
 * gezeichnet.
 * 
 * @author Stephan Bauer
 * @author Thomas Gradisnik
 * @author // FILL IN
 * @version 1.0
 * 
 */

public class ChristmasTree {

    /** 2D-boolean-Array (S/W-Bild) */
    private boolean[][] christmasTreeTemplate;

    private int width;
    private int height;

    /**
     * Konstruktor.
     * 
     * Initialisiert ein 2D-boolean-Array in der Größe des Konsolenfensters. Vom
     * Konstruktor aufgerufen aber ausgelagert ist die Methode draw, die in das
     * Array zeichnet.
     * 
     * @param width
     *            Breite des Konsolenfensters
     * @param height
     *            Höhe des Konsolenfensters
     */
    public ChristmasTree(int width, int height) {

	this.width = width;
	this.height = height;

	// Standardhelligkeit im Bild: 0 (=false)
	this.christmasTreeTemplate = new boolean[height][width];
	for (int i = 0; i < height; i++) {
	    Arrays.fill(this.christmasTreeTemplate[i], false);
	}

	// Weihnachtsbaum zeichnen
	this.draw();

    }

    /**
     * Zeichnet einen Weichnachtsbaum in das 2D-boolean-Array.
     * 
     * Zeichnet in das 2D-boolean-Array christmasTreeTemplate einen
     * Weihnachtsbaum. Die charakteristische Form hat folgendes Aussehen:
     * 
     *           *
     *          ***
     *         *****
     *        *******
     *       *********
     *      ***********
     *     *************
     *    ***************
     *   *****************
     *  *******************
     * *********************
     *        *******
     *        *******
     * 
     * Der Baum wird dabei mittig im Fenster ausgerichtet. Ein Drittel der
     * Fensterhöhe bleibt oberhalb des Baumes frei. Beim Zeichnen in das Gitter
     * wird an den entsprechenden Positionen der Wert auf true gesetzt (es wird
     * daher ein S/W-Bild erstellt, das als Helligkeitswerte lediglich 0 und 1
     * kennt).
     */
    private void draw() {

	// FILL IN

    }

    /**
     * Gibt den Helligkeitswert an der Stelle (x|y) zurück.
     * 
     * @param x
     *            Gitterposition in x-Richtung
     * @param y
     *            Gitterposition in y-Richtung
     */
    public boolean valueAt(int x, int y) {
	
	// FILL IN
	
	return false; // REMOVE THIS

    }

}
