import java.util.ArrayList;
import java.util.List;

public class Phonebook {

	private PhonebookEntry[] entries;
	private int count = 0;
	
	/**
	* Initialisiert dieses Telefonbuch als leeres Telefonbuch,
	* in dem keine Einträge stehen.
	* @param capacity Die Anzahl der Plätze im Telefonbuch.
	*/
	public Phonebook(int capacity) {
		
		entries = new PhonebookEntry[capacity];
	
	}
	
	/**
	* Fügt einen neuen Eintrag hinzu.
	* @param entry der Eintrag, der hinzugefügt wird.
	*/
	public void add(PhonebookEntry entry) {
		
		entries[count++] = entry;
		
	}
	
	/**
	* Löscht den Eintrag mit dem angegebenen Namen.
	* @param name der Eintrag mit diesem Namen soll gelöscht 
	* werden.
	*/
	public void remove(String name) {
	
		for (int i = 0; i < count; i++) {
		
			if (entries[i].name().equals(name)) {
			
				for (int j = i + 1; j < entries.length; j++) {			
					entries[j-1] = entries[j]; 
				}
				i--;
				count--;
			
			}
		
		
		}
	
	}
	
	/**
	* @return true wenn es noch freien Speicherplatz im Telefonbuch 
	* gibt, sonst false.
	*/
	public boolean hasFreeSlot() {
		
		return count < entries.length;
	
	}
	
	/**
	* @return eine lesbare Repräsentation des Telefonbuchs.
	*/
	public String toString() {
	
		String out = "";
		
		for (int i = 0; i < count; i++) {
			out += entries[i].toString() + "\n";
		}
		
		
		return out;
	
	}

}
