/**
* Ein spezieller Telefonbucheintrag, der eine einzelne Person
* repräsentiert.
*/
public class PersonEntry implements PhonebookEntry {
	
	private String name;
	private String phone;
	
	/**
	* Konstruktor: Initialisiert diesen Personeneintrag.
	*/
	public PersonEntry (String name, String phone) {
		
		this.name = name;
		this.phone = phone;
		
	}
	
	@Override
	/**
	* @return eine lesbare Repräsentation dieses Eintrags.
	*/
	public String toString() {
		
		return this.name + ": " + this.phone;
		
	}
	
	@Override
	/**
	* @return der Name der Person.
	*/
	public String name() {
		
		return this.name;
		
	}
	
	@Override
	/**
	* @return die Telefonnummer der Person.
	*/
	public String phone() {
		
		return this.phone;
		
	}
	
	@Override
	/** 
	* @param o ein Vergleichsobjekt.
	* @return liefert true, wenn
	* das angegebene Objekt ein Personeneintrag ist 
	* und der Name übereinstimmt, sonst false.
	*/
	public boolean equals(Object o) {
		
		if (this == o) {
			
			return true;
			
		} 
		
		if (null == o || !(o instanceof PersonEntry)) {
			
			
			return false;
			
		}
		
		return ((PersonEntry) o).name().equals(this.name());
		
	}
	
}
