/**
* Ein spezieller Telefonbucheintrag, der eine einzelne Person
* repräsentiert.
*/
public class PersonEntry extends PhonebookEntry {
	
	private String name;
	private String phone;
	
	/**
	* Konstruktor: Initialisiert diesen Personeneintrag.
	*/
	public PersonEntry (String name, String phone) {
		
		this.name = name;
		this.phone = phone;
		
	}
	
	@Override
	/**
	* @return eine lesbare Repräsentation dieses Eintrags.
	*/
	public String toString() {
		
		return this.name + ": " + this.phone;
		
	}
	
	@Override
	/**
	* @return der Name der Person.
	*/
	public String name() {
		
		return this.name;
		
	}
	
	@Override
	/**
	* @return die Telefonnummer der Person.
	*/
	public String phone() {
		
		return this.phone;
		
	}
	
}
