import java.util.ArrayList;
import java.util.List;
import java.util.HashMap;
import java.util.Iterator;

public class Phonebook {

	//private PhonebookEntry[] entryMap;
	private HashMap<String, PhonebookEntry> entryMap;
	
	/**
	* Initialisiert dieses Telefonbuch als leeres Telefonbuch,
	* in dem keine Einträge stehen.
	*/
	public Phonebook() {
		
		entryMap = new HashMap<String, PhonebookEntry>();
	
	}
	
	/**
	* Fügt einen neuen Eintrag hinzu.
	* @param entry der Eintrag, der hinzugefügt wird.
	*/
	public void add(PhonebookEntry entry) {
		
		entryMap.put(entry.name(), entry);
		
	}
	
	public PhonebookEntry get(String name) {
	
		return entryMap.get(name);
	
	}
	
	
	/**
	* Löscht den Eintrag mit dem angegebenen Namen.
	* @param name der Eintrag mit diesem Namen soll gelöscht 
	* werden.
	*/
	public void remove(String name) {
	
		entryMap.remove(name);
		
	}
	
	/**
	* Liefert eine Liste mit allen im Telefonbuch 
	* gespeicherten Matrikelnummern.
	* @return eine Liste mit allen Matrikelnummern. 
	*/
	public List<Integer> getMatrNrList() {
	
		ArrayList<Integer> list = new ArrayList<Integer>();
		
		//FILL IN
		
		for(PhonebookEntry entry: this.entryMap.values()) {
		
			if(entry instanceof StudentEntry) {
				
				list.add(((StudentEntry) entry).matrNr());
			
			}
		
		}
	
		return list;
	
	}
	
	/**
	* @return eine lesbare Repräsentation des Telefonbuchs.
	*/
	public String toString() {
	
		String out = "";
		
		Iterator<PhonebookEntry> iterator = this.entryMap.values().iterator();
		
		while(iterator.hasNext()) {
			out += iterator.next().toString() + "\n";
		}
		
		
		return out;
	
	}

}
