/**
* Ein Telefonbucheintrag mit Name und dazugehöriger Telefonnummer.
*/
public abstract class PhonebookEntry {

	/**
	* @return der Name des Eintrags. Mit diesem 
	* Namen kann im Telefonbuch gesucht werden.
	*/
	public abstract String name();
	
	/**
	* @return die Telefonnummer.
	*/
	public abstract String phone();
	
	@Override
	/** 
	* @param o ein Vergleichsobjekt.
	* @return liefert true, wenn
	* das angegebene Objekt ein entsprechender Telefonbucheintrag ist 
	* und der Name übereinstimmt, sonst false.
	*/
	public boolean equals(Object o) {
		
		if (this == o) {
			
			return true;
			
		} 
		
		if (null == o || !(o.getClass() == this.getClass())) {
			
			
			return false;
			
		}
		
		return ((PersonEntry) o).name().equals(this.name());
		
	}

}
