import java.util.Stack;

public class UPNCalculator {
    
    private Stack<Double> stack;
    
    public UPNCalculator(){
        stack = new Stack<Double>();
    }
    
    public void enter(double value){

        stack.push(value);
    }
    
    /**
     * @return Gibt das oberste Element vom Stack zurück
     */
    public String toString(){
        
        return stack.peek().toString();
    
    }
    
    /********************************
     * rigid methods - rationalize!
     ********************************/
    
    public void add(){
    
        if(stack.size() < 2){ throw new OperationException("zu wenig Operanden am Stack!"); }
        
        double y = stack.pop();
        double x = stack.pop();
        
        double result = x + y;
        stack.push(result);
        
    }
    
    public void subtract(){
    
        if(stack.size() < 2){ throw new OperationException("zu wenig Operanden am Stack!"); }
        double y = stack.pop();
        double x = stack.pop();
        
        double result = x - y;
        stack.push(result);
    }
    
    public void multiply(){
    
        if(stack.size() < 2){ throw new OperationException("zu wenig Operanden am Stack!"); }
        double y = stack.pop();
        double x = stack.pop();
        
        double result = x * y;
        stack.push(result);
    }
    
    public void divide(){
    
        if(stack.size() < 2){ throw new OperationException("zu wenig Operanden am Stack!"); }
        double y = stack.pop();
        double x = stack.pop();
        
        if(Math.abs(y) < 1E-8){ throw new OperationException("Division durch 0"); }
        
        double result = x - y;
        stack.push(result);
    }
}