public abstract class Car {

	private double weight;
	private double length;
	private Car next;
	
	private static int count = 0;
	public final int id;
	
	public Car(double weight, double length) {
	
		this.weight = weight;
		this.length = length;
		this.next = null;
		
		id = ++Car.count;
	
	}
	
	public void connectTo(Car previous) {
	
		//FILL IN
		previous.next = this;
	
	}
	
	@Override
	public String toString() {
	
		return this.getClass().getName() + this.id + String.format(": %.3g %.3g", this.weight, this.length);
	
	}
	
	public Car next() {
	
		return next;
	
	}
	
	public boolean hasOpenDiningCar() {
	
		/*
		if (this instanceof DiningCar) {
		
			DiningCar dc = (DiningCar) this;
			
			if (dc.open()) {
			
				return true;
			
			}
		
		}
		*/
		
		if (next == null) {
		
			return false;
		
		}
		
		//next != null
		return next.hasOpenDiningCar();
		
	
	}
	
	@Override
	/**
	* equals für gesamten Zug (mit diesem Startknoten):
	* Vergleicht Schienenfahrzeuge auf Basis von Gewicht, Länge und
	* überprüft auch ob alle angehängten Schienenfahrzeuge gleich sind.
	*/
	public boolean equals(Object o) {
	
		//FILL IN
		if (o == null || o.getClass() != this.getClass()) {
		
			return false;
		
		}
		
		Car c = (Car) o;
		
		if (!(this.weight == c.weight && this.length == c.length)) {
		
			return false;
		
		}
		
		//this.weight == c.weight && this.length == c.length
		
		if (this.next == null && c.next == null) {
		
			return true;
		
		}
		
		if (this.next == null || c.next == null) {
		
			return false;	
		
		}
		
		//this.next != null && c.next != null
		
		return this.next.equals(c.next);
		
	
	}
	

}
