public class Tree implements Operation {
	
	private String indent = "";
	
	public Directory execute(Directory dir) {
		
		System.out.println(indent + "+" + dir.name());
		
		String lastIndent = indent;
		indent += "   ";
		
		for(DirectoryEntry de: dir.list()) {
			
			if (de instanceof File) {
				
				System.out.println(indent + de.name());
				
			} else {
				
				this.execute((Directory)de);
				
			}
			
		}
		
		indent = lastIndent;
		
		return dir;
		
	}
	
}


//Ausgabe:
//+root
//   test.txt
//   +html
//      index.html
//   +cgi
//      test.sh
//      test.pl
//      test.py


